﻿using System;
using System.Collections.Generic;
using System.Reflection;
using System.Text;
using UnityEngine;
using System.Linq;
using System.IO;
using System.Collections;
using UnityEngine.SceneManagement;
using Steamworks;

public class StopHooks : Mod
{
    private List<Item_Base> items = new List<Item_Base>();
    ItemInstance currentItem;
    string Slot1 = "null";
    bool hookEnable = false;
    static StopHooks instance;

    public void Start()
    {
        instance = this;

        GenerateList();
        Debug.Log("StopHooks has been loaded!");
    }

    public void Update()
    {
        if (currentItem == null && RAPI.GetLocalPlayer())
        {
            currentItem = RAPI.GetLocalPlayer().Inventory.GetSelectedHotbarItem();
        }
        else return;
    }

    public override void WorldEvent_WorldLoaded()
    {
        RAPI.GetLocalPlayer().Inventory.RemoveItem("Hook_Plastic", 1);
    }

    private void CheckCommands()//This is where it checks which command was called
    {
        string[] lastCommand = RConsole.lastCommands.LastOrDefault().Split(' ');//stores all the last commands in an array

        if (lastCommand.Length == 1)
        {
            Help();
            return;
        }
        string caseSwitch = lastCommand[1];//Checks the first one only

        switch (caseSwitch)//send the rest of the commands to functions
        {
            case "help":
                Help();
                break;
            case "slotSet1":
                SlotSet1();
                break;
            case "toggleHooks":
                ToggleHooks();
                break;
        }

    }

    private void GenerateList()
    {
        items = ItemManager.GetAllItems();
    }

    public void Help()
    {
        Debug.Log("-- Stop Hooks Help Page 1/1 --");
        Debug.Log("StopHooks help OR StopHooks -- Opens this menu");
        Debug.Log("StopHooks slotSet1 ITEMNAME -- make another item unobtainable");
        Debug.Log("StopHooks toggleHooks -- toggle whether or not hooks are unobtainable");
    }

    public void ToggleHooks()
    {
        hookEnable = !hookEnable;
        if (hookEnable == true)
            Debug.Log("Hooks are now enabled");
        if (hookEnable == false)
            Debug.Log("Hooks are now disabled");
    }

    public void SlotSet1()
    {
        string[] lastCommand = RConsole.lastCommands.LastOrDefault().Split('1');
        if (lastCommand[1].Length <= 1)
        {
            Debug.Log("Please include an item name after the commands,  e.g. \"slotSet1 Paddle\"");
        }
        else
        {
            string itemName = lastCommand[1];
            for (int i = 0; i < items.Count; i++)
            {
                if (" " + items[i].UniqueName == itemName)
                {
                    try
                    {
                        Slot1 = items[i].UniqueName;
                        Debug.Log("You now cannot make: " + items[i].UniqueName);
                    }
                    catch (Exception e)
                    {
                        Debug.LogError(e.ToString());
                    }
                    return;
                }
                else if (i == items.Count - 1)
                {
                    Debug.Log("Couldn't find the existing item you want to stop making: " + itemName);
                }
            }
        }
    }

    public override void LocalPlayerEvent_PickupItem(PickupItem item)
    {
        if (item.itemInstance.UniqueName == Slot1)
        {
            RAPI.GetLocalPlayer().Inventory.RemoveItem(Slot1, 10);
        }
        if (hookEnable == false)
        {
            if (item.itemInstance.UniqueName == "Hook_Scrap")
            {
                RAPI.GetLocalPlayer().Inventory.RemoveItem("Hook_Scrap", 10);
            }
            if (item.itemInstance.UniqueName == "Hook_Plastic")
            {
                RAPI.GetLocalPlayer().Inventory.RemoveItem("Hook_Plastic", 10);
            }
        }
    }

    public override void LocalPlayerEvent_ItemCrafted(Item_Base item)
    {
        if (item.UniqueName == Slot1)
        {
            RAPI.GetLocalPlayer().Inventory.RemoveItem(Slot1, 1);
        }
        if (hookEnable == false)
        {
            if (item.UniqueName == "Hook_Plastic")
            {
                RAPI.GetLocalPlayer().Inventory.RemoveItem("Hook_Plastic", 1);
            }
            if (item.UniqueName == "Hook_Scrap")
            {
                RAPI.GetLocalPlayer().Inventory.RemoveItem("Hook_Scrap", 1);
            }
        }
    }

    public void OnModUnload()
    {
        Debug.Log("StopHooks has been unloaded!");
    }

    [ConsoleCommand(name: "stophooks", docs: "Main Command Syntax")]
    public static void MyCommand(string[] args)
    {
        instance.CheckCommands();
    }
}